package com.company.demo.screen.customer;

import com.company.demo.entity.Customer;
import io.jmix.core.LoadContext;
import io.jmix.core.Metadata;
import io.jmix.ui.model.CollectionContainer;
import io.jmix.ui.screen.*;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.ArrayList;
import java.util.List;

@UiController("CustomerScreen")
@UiDescriptor("customer-screen.xml")
public class CustomerScreen extends Screen {

    private static final int COUNT = 500000;

    @Autowired
    protected CollectionContainer<Customer> customersDc;
    @Autowired
    protected Metadata metadata;

    protected List<Customer> items;

    @Subscribe
    protected void onInit(InitEvent event) {
        items = new ArrayList<>();
        for (int i = 0; i < COUNT; i++) {
            Customer customer = metadata.create(Customer.class);
            customer.setName("First Name " + i);
            customer.setLastName("Last Name " + i);
            items.add(customer);
        }
    }

    @Install(to = "customerDl", target = Target.DATA_LOADER)
    protected List<Customer> customerDlLoadDelegate(LoadContext<Customer> loadContext) {
        return items;
    }

}